_G.love = require("love")
math.randomseed(os.time())

function love.load( ... )
    
    -- Loaded libraries
    
    SCREEN_WIDTH = love.graphics.getWidth()
    SCREEN_HEIGHT = love.graphics.getHeight()

    wf = require("libraries/windfield")
    world = wf.newWorld(0, 0)
    
    camera = require("libraries/camera")
    cam = camera()
    
    anim8 = require("libraries/anim8")
    love.graphics.setDefaultFilter("nearest", "nearest")
    
    sti = require ("libraries/sti")
    game_map = sti("maps/dungeon.lua")
    
    world:addCollisionClass('solid')
    world:addCollisionClass('Passthrough')
    world:addCollisionClass('Player')
    world:addCollisionClass('enemies',{ignores = {'Player'}})
    world:addCollisionClass('ghosts', {ignores= {'Player', 
                                                 'enemies',
                                                 'solid'}})
    world:addCollisionClass('arrows', {ignores = {'Player',
                                                'ghosts',
                                                'arrows',
                                                'enemies'}})
    world:addCollisionClass('axes', {ignores = {'Player', 
                                                'solid',
                                                'ghosts',
                                                'arrows',
                                                'axes',
                                                'enemies'}})
                                                
    world:addCollisionClass('saw', {ignores = {'Player', 
    'solid',
    'ghosts',
    'arrows',
    'axes',
    'enemies',
    'saw'}})
    world:collisionClassesSet()

    -- Gamestats: 
        -- 1 - Main Menu
        -- 2 - Playing
        -- 3 - Level up
        -- 4 - Pause
        -- 5 - Game Over
        -- 6 - Settings

    -- Game properties
    gamestate = {}
    gamestate.state = 2
    gamestate.scale = 2
    gamestate.spawnRate = 1
    gamestate.spawnTimer = gamestate.spawnRate
    gamestate.minSpawnTimer = 0.1
    gamestate.currentSpawnTimer = gamestate.spawnRate
    gamestate.playerNoDamageRate = 0.5
    gamestate.playerNoDamageTimer = gamestate.playerNoDamageRate
    gamestate.levelupMessageTime = 1
    gamestate.levelupMessageTimer = gamestate.levelupMessageTime 
    gamestate.notification = ""
    gamestate.showNotification = false
    gamestate.showNotificationRate = 3
    gamestate.showNotificationTimer = gamestate.showNotificationRate
    gamestate.showstats = false
    gamestate.starttime = 0 
    gamestate.runningTime = 0

    -- Collection of sprites
    sprites = {}
    sprites.player = love.graphics.newImage("sprites/spritesheet.png")
    sprites.arrowUP = love.graphics.newImage("sprites/Arrow01UP.png")
    sprites.arrowDOWN = love.graphics.newImage("sprites/Arrow01DOWN.png")
    sprites.arrowLEFT = love.graphics.newImage("sprites/Arrow01LEFT.png")
    sprites.arrowRIGHT = love.graphics.newImage("sprites/Arrow01RIGHT.png")
    sprites.spider = love.graphics.newImage("sprites/spider.png")
    sprites.ghost = love.graphics.newImage("sprites/ghost.png")
    sprites.bat = love.graphics.newImage("sprites/bat.png")
    sprites.potion = love.graphics.newImage("sprites/potion.png")
    sprites.magnet = love.graphics.newImage("sprites/magnet.png")
    sprites.bomb = love.graphics.newImage("sprites/bomb.png")
    sprites.axe = love.graphics.newImage("sprites/axe.png")
    sprites.saw = love.graphics.newImage("sprites/axe.png")

    -- Player properties
    player = {}
    player.x = 800
    player.y = 900
    player.collider = world:newBSGRectangleCollider(player.x,player.y,22,42,8)
    player.collider:setFixedRotation(true)
    player.collider:setCollisionClass('Player')
    player.speed = 150
    player.maxhp = 100
    player.hp = 100
    player.armor = 0
    player.level = 1
    player.xp = 9
    player.maxXP = 10
    player.critrate = 5
    player.critdmg = 2.5
    player.radius = 100
    player.nodamage = false
    player.lvlup = false
    player.grid = anim8.newGrid(72,72,sprites.player:getWidth(), sprites.player:getHeight() )
    player.animations = {}
    player.animations.down = anim8.newAnimation(player.grid("1-4", 1), 0.2)
    player.animations.left = anim8.newAnimation(player.grid("1-4", 2), 0.2)
    player.animations.right = anim8.newAnimation(player.grid("1-4", 3), 0.2)
    player.animations.up = anim8.newAnimation(player.grid("1-4", 4), 0.2)
    player.direction = player.animations.down

    enemies = {}
        enemies.spawnpoints = {{2,760},{33,277},{40,700},{71,100},{84,411},{120,590},{207,60},{207,740},{281,623},
                             {300,700},{350,48},{400,100},{400,160},{400,648},{400,320},{445,450},{483,415},{500,90},
                             {500,500},{516,706},{538,238},{600,460},{660,175},{700,248},{700,448},{700,600},{700,748}}
        enemies.spawntable = {}
        enemies.spiders = {}
            enemies.spiders.speed = 60
            enemies.spiders.dead = false
            enemies.spiders.isHit = false
        enemies.ghosts = {}
            enemies.ghosts.speed = 80
            enemies.ghosts.dead = false
        enemies.bats = {}
            enemies.bats.speed = 90
            enemies.bats.dead = false

    --Projectile Properties

    projectiles = {}
        projectiles.arrow_plus = {}
            projectiles.arrow_plus.speed = 300
            projectiles.arrow_plus.firerate = 1
            projectiles.arrow_plus.timer = projectiles.arrow_plus.firerate
            projectiles.arrow_plus.damage = 1
            projectiles.arrow_plus.hp = 3
            projectiles.arrow_plus.up = {}
                projectiles.arrow_plus.up.dead = false
            projectiles.arrow_plus.down = {}
                projectiles.arrow_plus.down.dead = false
            projectiles.arrow_plus.left = {}
                projectiles.arrow_plus.left.dead = false
            projectiles.arrow_plus.right = {}
                projectiles.arrow_plus.right.dead = false
        projectiles.axe = {}
            projectiles.axe.hp = 5
            projectiles.axe.speed = 200
            projectiles.axe.firerate = 2
            projectiles.axe.timer =  projectiles.arrow_plus.firerate
            projectiles.axe.damage = 5
        projectiles.saw = {}
            projectiles.saw.speed = 150
            projectiles.saw.damage = 2

    worldobjects = {}
        worldobjects.xp = {}
            worldobjects.xp.x = 0
            worldobjects.xp.y = 0
            worldobjects.items = {}
            worldobjects.items.fn = nil
            worldobjects.allitems = {
                potion = {   
                    name = "Health potion",
                    description = "Heals the Player by 60 Points.",
                    sprite = sprites.potion,
                    fn = healPlayerHP,
                },
                magnet = {
                    name = "Magnet",
                    description = "Collects all XP on Map.",
                    sprite = sprites.magnet,
                    fn = getallXP,
                },
                bomb ={
                    name = "Bomb",
                    description = "Damages all enemies",
                    sprite = sprites.bomb,
                    fn = bomb_damage,
                }
            }

    fonts = {}
        fonts.defaultFont = love.graphics.newFont(14)
        fonts.PixelFontNormal = love.graphics.newFont("/fonts/dogicapixel.ttf", 14)
        fonts.PixelFontSmall = love.graphics.newFont("/fonts/dogicapixel.ttf", 10)

    buttons = {}
        buttons.upgrades = {}
        buttons.upgrades_available = {}
        buttons.pause = {}
        buttons.mainmenu = {}

    -- World Properties
   
    walls = {}

    if game_map.layers["Walls"] then
        for i, obj in pairs(game_map.layers["Walls"].objects) do
            local wall = world:newRectangleCollider(obj.x*gamestate.scale, obj.y*gamestate.scale, obj.width*gamestate.scale, obj.height*gamestate.scale)
            wall:setType("static")
            wall:setCollisionClass('solid')
            table.insert(walls, wall)
        end
    end
    
    spawnSaw()
end

function love.update(dt)
    if gamestate.state == 2 then
    -- Walking the player + animation
    local isMoving = false
    
    local vx = 0 -- Velocity of x direction of collider
    local vy = 0 -- Velocity of y direction of collider
    
    if love.keyboard.isDown("up") then
        vy = player.speed * -1
        player.direction = player.animations.up
        isMoving = true
    end
    
    if love.keyboard.isDown("down") then
        vy = player.speed
        player.direction = player.animations.down
        isMoving = true
    end
    
    if love.keyboard.isDown("right") then
        vx = player.speed
        player.direction = player.animations.right
        isMoving = true
    end

    if love.keyboard.isDown("left") then
        vx = player.speed * -1
        player.direction = player.animations.left
        isMoving = true
    end
    
    if isMoving == false then
        player.direction:gotoFrame(2)
    end

    player.direction:update(dt)
    player.collider:setLinearVelocity(vx, vy)
    player.x = player.collider:getX()
    player.y = player.collider:getY()
    
    -- Movement Update + Collider for Arrow_plus

    handleArrowPlusMovement()
    handleArrowPlusColissionAll()
    handleAxeMovement()
    handleAxeColission()
    handleSawMovement()
-- Game Handling, Enemy Movement, Collissions and Collecting

    handleEnemies(enemies.spiders, 1)
    handleEnemies(enemies.ghosts, 3)
    handleEnemies(enemies.bats, 5)
    collectXPandItems()
    
    -- Update Player

   UpdatePlayer()

    -- Parameters for Camera

    cam:lookAt(player.x,player.y) -- Camera on Player Position

    -- Prevents black borders at edge of game_map

    local w, h = love.graphics.getWidth(), love.graphics.getHeight()
    local map_w, map_h = game_map.width * game_map.tilewidth, game_map.height * game_map.tileheight

    if cam.x < w/2 then
        cam.x = w/2
    end
    if cam.y < h/2 then
        cam.y = h/2
    end
    if cam.x > (map_w*gamestate.scale - w/2) then
        cam.x = (map_w*gamestate.scale - w/2)
    end
    if cam.y > (map_h*gamestate.scale - h/2) then
        cam.y = (map_h*gamestate.scale - h/2)
    end

    -- Automatically spawn enemies und arrows

    SpawnEnemies(dt)
    projectiles.arrow_plus.timer = projectiles.arrow_plus.timer - dt
    if projectiles.arrow_plus.timer <= 0 then
        spawnArrows_plus()
        projectiles.arrow_plus.timer = projectiles.arrow_plus.firerate
    end
    projectiles.axe.timer = projectiles.axe.timer - dt
    if projectiles.axe.timer <= 0 then
        spawnAxe()
        projectiles.axe.timer = projectiles.axe.firerate
    end

    if player.nodamage == true then
        gamestate.playerNoDamageTimer =  gamestate.playerNoDamageTimer - dt
        if gamestate.playerNoDamageTimer <= 0 then
            player.nodamage = false
            gamestate.playerNoDamageTimer = gamestate.playerNoDamageRate
        end
    end

    if gamestate.showNotification == true then
        gamestate.showNotificationTimer =  gamestate.showNotificationTimer - dt
        if gamestate.showNotificationTimer <= 0 then
            gamestate.showNotification = false
            gamestate.notification = ""
            gamestate.showNotificationTimer = gamestate.showNotificationRate
        end
    end

    gamestate.starttime = math.floor(love.timer.getTime())
    world:update(dt)
    elseif gamestate.state == 3 then
        vx, vy = 0,0
    elseif gamestate.state == 4 then
    end

    if love.keyboard.isDown("tab") then
        gamestate.showstats = true
    
    else
        gamestate.showstats = false
    end
   
end

function love.draw( ... )
    
    if gamestate.state == 2 then
    cam:attach()

    love.graphics.setFont(fonts.defaultFont)

    -- Scales the map by the factor of gamestate.scale
    love.graphics.push()
    love.graphics.scale(gamestate.scale)

        -- Draws every layer
        game_map:drawLayer(game_map.layers["Ground"])
        game_map:drawLayer(game_map.layers["Second Layer"])
        game_map:drawLayer(game_map.layers["Deco"])

    love.graphics.pop()

    -- Draws the player and its animation at xy, with scaling 0.8 
    drawPlayer()
    
    -- Scales the map by the factor of gamestate.scale
    love.graphics.push()
    love.graphics.scale(gamestate.scale)
        
        -- Draws last layer
        game_map:drawLayer(game_map.layers["Above Player"])
    
    love.graphics.pop()

    drawAllEnemies()
    drawXP()
    drawItems()
    drawAllWeapons()
    drawSaw()

    world:draw()  -- Function to draw Colissions
    cam:detach()    -- Everything below here is static on screen, will not be moved with camera
    drawHUD()
    drawNotification()
    love.graphics.print("X: " .. math.floor(player.x)/2, 0,25)
    love.graphics.print("Y: " .. math.floor(player.y)/2, 0,50)
    love.graphics.print(#projectiles.arrow_plus.up, 0,75)
    love.graphics.print(#enemies.spiders + #enemies.bats + #enemies.ghosts, 0,100)
    
    elseif gamestate.state == 3 then
        drawMapNoPlayer()
        drawLvLUp()
    
    elseif gamestate.state == 4 then
        drawMapNoPlayer()
        drawPause()
    elseif gamestate.state == 5 then
        drawMapNoPlayer()
        drawGameOver()
    end
    -- Player stats
    if gamestate.showstats and  gamestate.state == 2 or gamestate.showstats and gamestate.state == 3 then
        drawPlayerStats()
    end
end

--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------

function enemyPlayerAngle(enemy)
    return math.atan2 (player.y - enemy.y, player.x - enemy.x)
end

function SpawnSpider()
    local spider = {}
    local spawnpoint = math.random(1, #enemies.spawnpoints)
    spider.x, spider.y = enemies.spawnpoints[spawnpoint][1]*gamestate.scale, enemies.spawnpoints[spawnpoint][2]*gamestate.scale
    spider.maxhp = 3
    spider.hp = 3
    spider.damage = 5
    spider.dead = false
    spider.collider = world:newBSGRectangleCollider(spider.x, spider.y, 19,19,5)
    spider.collider:setFixedRotation(true)
    spider.collider:setCollisionClass('enemies')
    table.insert(enemies.spiders, spider)
end

function SpawnGhost()
    local ghost = {}
    local spawnpoint = math.random(1, #enemies.spawnpoints)
    ghost.x, ghost.y = enemies.spawnpoints[spawnpoint][1]*gamestate.scale, enemies.spawnpoints[spawnpoint][2]*gamestate.scale
    ghost.maxhp = 5
    ghost.hp = 5
    ghost.damage = 10
    ghost.dead = false
    ghost.collider = world:newBSGRectangleCollider(ghost.x, ghost.y, 19,19,5)
    ghost.collider:setFixedRotation(true)
    ghost.collider:setCollisionClass('ghosts')
    table.insert(enemies.ghosts, ghost)
end

function SpawnBat()
    local bat = {}
    local spawnpoint = math.random(1, #enemies.spawnpoints)
    bat.x, bat.y = enemies.spawnpoints[spawnpoint][1]*gamestate.scale, enemies.spawnpoints[spawnpoint][2]*gamestate.scale
    bat.maxhp = 8
    bat.hp = 8

    bat.damage = 15
    bat.dead = false
    bat.collider = world:newBSGRectangleCollider(bat.x, bat.y, 19,19,5)
    bat.collider:setFixedRotation(true)
    bat.collider:setCollisionClass('enemies')
    table.insert(enemies.bats, bat)
end

function dropXP(x,y, value)
    local xp = {}
    xp.x = x
    xp.y = y
    xp.value = value
    xp.magnet = false
    table.insert(worldobjects.xp, xp)
end

function dropitem(x,y,sprite,fn)
    local item = {}
    item.x = x
    item.y = y
    item.fn = fn
    item.sprite = sprite
    table.insert(worldobjects.items, item)
end

function RandomItem(x, y)
    local keys = {}
    for key in pairs(worldobjects.allitems) do
        table.insert( keys, key)
    end 
    local randomindex = math.random(#keys)
    local randomkey = keys[randomindex]
    local item = worldobjects.allitems[randomkey]
    dropitem(x, y, item.sprite, item.fn)
end

function spawnArrows_plus()
        
    local arrowup = {}
    local arrowdown= {}
    local arrowleft= {}
    local arrowright = {}
    arrowdown.x, arrowleft.x, arrowright.x, arrowup.x = player.x-3, player.x -33, player.x + 35, player.x-3
    arrowdown.y, arrowleft.y, arrowright.y, arrowup.y = player.y+25, player.y-2, player.y-2, player.y - 50
    arrowup.hp = projectiles.arrow_plus.hp
    arrowup.collider = world:newRectangleCollider(arrowup.x, arrowup.y, 7,2)
    arrowup.collider:setFixedRotation(true)
    arrowup.collider:setCollisionClass('arrows')
   
    arrowdown.hp = projectiles.arrow_plus.hp
    arrowdown.collider = world:newRectangleCollider(arrowdown.x, arrowdown.y, 7,2)
    arrowdown.collider:setFixedRotation(true)
    arrowdown.collider:setCollisionClass('arrows')

    arrowleft.hp = projectiles.arrow_plus.hp
    arrowleft.collider = world:newRectangleCollider(arrowleft.x,arrowleft.y, 2,7)
    arrowleft.collider:setFixedRotation(true)
    arrowleft.collider:setCollisionClass('arrows')

    arrowright.hp = projectiles.arrow_plus.hp
    arrowright.collider = world:newRectangleCollider(arrowright.x, arrowright.y,2,7)
    arrowright.collider:setFixedRotation(true)
    arrowright.collider:setCollisionClass('arrows')

    table.insert(projectiles.arrow_plus.down, arrowdown )
    table.insert(projectiles.arrow_plus.left, arrowleft )
    table.insert(projectiles.arrow_plus.right, arrowright )
    table.insert(projectiles.arrow_plus.up, arrowup )

end

function spawnAxe()
    local axe = {}
    axe.x, axe.y = player.x, player.y
    axe.hp = projectiles.axe.hp
    axe.collider = world:newBSGRectangleCollider(axe.x-12, axe.y-12, 24,24, 15)
    axe.collider:setFixedRotation(true)
    axe.collider:setCollisionClass('axes')
    direction = math.random(1,8)
    if direction == 1 then
        axe.ax = 0
        axe.ay  = projectiles.axe.speed * -1
    elseif direction == 2 then
        axe.ax = 0
        axe.ay = projectiles.axe.speed
    elseif direction == 3 then
        axe.ax = projectiles.axe.speed
        axe.ay = 0
    elseif direction == 4 then
        axe.ax = projectiles.axe.speed * -1
        axe.ay = 0
    elseif direction == 5 then
        axe.ay = projectiles.axe.speed
        axe.ax = projectiles.axe.speed * -1
    elseif direction == 6 then
        axe.ay = projectiles.axe.speed * -1
        axe.ax = projectiles.axe.speed * -1
    elseif direction == 7 then
        axe.ay = projectiles.axe.speed * -1
        axe.ax = projectiles.axe.speed
    else
        axe.ay = projectiles.axe.speed
        axe.ax = projectiles.axe.speed
    end 
    
    table.insert(projectiles.axe, axe )

end



function spawnRandomAssWeapon()
    local axe = {}
    axe.x, axe.y = player.x, player.y
    axe.hp = projectiles.axe.hp
    axe.collider = world:newBSGRectangleCollider(axe.x-12, axe.y-12, 24,24, 15)
    axe.collider:setFixedRotation(true)
    axe.collider:setCollisionClass('axes')
    --direction = math.random(1,8)
    --[[ if direction == 1 then
        axe.ax = 0
        axe.ay  = projectiles.axe.speed * -1
    elseif direction == 2 then
        axe.ax = 0
        axe.ay = projectiles.axe.speed
    elseif direction == 3 then
        axe.ax = projectiles.axe.speed
        axe.ay = 0
    elseif direction == 4 then
        axe.ax = projectiles.axe.speed * -1
        axe.ay = 0
    elseif direction == 5 then
        axe.ay = projectiles.axe.speed
        axe.ax = projectiles.axe.speed * -1
    elseif direction == 6 then
        axe.ay = projectiles.axe.speed * -1
        axe.ax = projectiles.axe.speed * -1
    elseif direction == 7 then
        axe.ay = projectiles.axe.speed * -1
        axe.ax = projectiles.axe.speed
    else
        axe.ay = projectiles.axe.speed
        axe.ax = projectiles.axe.speed
    end ]]
    direction = math.random(-100, 100)/100
    axe.ax = projectiles.axe.speed * direction
    direction = math.random(-100, 100)/100
    axe.ay = projectiles.axe.speed * direction
    table.insert(projectiles.axe, axe )

end

function distanceBetween (x1, y1, x2, y2)
    return math.sqrt( (x2 - x1)^2 + (y2 - y1)^2)
end

function handleEnemies(enemytable, xpvalue)

    for i, s in ipairs(enemytable) do
        ax = math.cos(enemyPlayerAngle(s)) * enemytable.speed
        ay = math.sin(enemyPlayerAngle(s)) * enemytable.speed
        s.collider:setLinearVelocity(ax,ay)
        s.x = s.collider:getX()
        s.y = s.collider:getY()
        local ax, ay = 0, 0
    end

    for i=#enemytable, 1, -1 do
        local s = enemytable[i]
        if s.collider:enter('arrows') then
            local damage =  calc_damage(projectiles.arrow_plus) 
            s.hp = s.hp - damage
        end
        if s.collider:enter('axes') then
            local damage =  calc_damage(projectiles.axe)
            s.hp = s.hp - damage
        end
        if s.collider:enter('Player') and player.nodamage == false then
            player.hp = player.hp - player.armor - s.damage
            player.nodamage = true
        end
        if s.hp <= 0 then
            s.dead = true
        end
        if s.dead == true then
            local itemdrop = math.random(1,100)
            if itemdrop < 6 then
                RandomItem(s.x, s.y)
            end
            dropXP(s.x, s.y, xpvalue)
            s.collider:destroy()
            table.remove(enemytable, i)
        end
    end
end

function handleArrowPlusColissionAll()
    handleArrowPlusColission(projectiles.arrow_plus.up)
    handleArrowPlusColission(projectiles.arrow_plus.down)
    handleArrowPlusColission(projectiles.arrow_plus.left)
    handleArrowPlusColission(projectiles.arrow_plus.right)
end

function handleArrowPlusColission(tbl)   

    for i=#tbl, 1, -1 do
        local s = tbl[i]
        if s.collider:enter('enemies') then
            s.hp = s.hp - 1
        end
        if s.collider:enter('ghosts') then
            s.hp = s.hp - 1
        end
        if s.hp <= 0 then
            s.dead = true
        end
        if s.collider:enter('solid') then
            s.dead = true
        end
        if s.dead == true then
            s.collider:destroy()
            table.remove(tbl, i)
        end
    end
end

function handleArrowPlusMovement()

    for i,ap in ipairs(projectiles.arrow_plus.up) do
        local ax, ay = 0,0
        ay  = projectiles.arrow_plus.speed * -1
        ap.collider:setLinearVelocity(ax, ay)
        ap.x = ap.collider:getX()
        ap.y = ap.collider:getY()
    end 

    for i,ap in ipairs(projectiles.arrow_plus.down) do
        local ax, ay = 0,0
        ay  = projectiles.arrow_plus.speed
        ap.collider:setLinearVelocity(ax, ay)
        ap.x = ap.collider:getX()
        ap.y = ap.collider:getY()
    end
       
    for i,ap in ipairs(projectiles.arrow_plus.right) do
        local ax, ay = 0,0
        ax  = projectiles.arrow_plus.speed
        ap.collider:setLinearVelocity(ax, ay)
        ap.x = ap.collider:getX()
        ap.y = ap.collider:getY()
    end
    
    for i,ap in ipairs(projectiles.arrow_plus.left) do
        local ax, ay = 0,0
        ax  = projectiles.arrow_plus.speed * -1
        ap.collider:setLinearVelocity(ax, ay)
        ap.x = ap.collider:getX()
        ap.y = ap.collider:getY()
    end
end

function handleAxeColission()   

    for i=#projectiles.axe, 1, -1 do
        local s = projectiles.axe[i]
        if s.collider:enter('enemies') then
            s.hp = s.hp - 1
        end
        if s.collider:enter('ghosts') then
            s.hp = s.hp - 1
        end
        if s.hp <= 0 then
            s.dead = true
        end
        if s.collider:enter('solid') then
            s.dead = true
        end
        if s.dead == true then
            s.collider:destroy()
            table.remove(projectiles.axe, i)
        end
    end
end

function handleAxeMovement()

    for i,a in ipairs(projectiles.axe) do
        local ax, ay = a.ax,a.ay
        a.collider:setLinearVelocity(ax, ay)
        a.x = a.collider:getX()
        a.y = a.collider:getY()
    end    
end

function spawnSaw()
    local saw = {}
    saw.x, saw.y = player.x+9, player.y+ 9
    saw.hp = projectiles.saw.hp
    saw.collider = world:newBSGRectangleCollider(saw.x, saw.y, 16,16, 15)
    saw.collider:setFixedRotation(true)
    saw.collider:setCollisionClass('saw')
    saw.angle = 0
    saw.vx = 0
    saw.vy = 0
    
    table.insert(projectiles.saw, saw )
end

function handleSawMovement()

    for i,a in ipairs(projectiles.saw) do
        local vx, vy = a.vx,a.vy
        a.angle = love.timer.getTime() * math.pi
        a.collider:setAngle(a.angle)
        a.collider:setLinearVelocity(vx, vy)
        a.x = a.collider:getX()
        a.y = a.collider:getY()
    end    
end

function collectXPandItems()
    
    for i=#worldobjects.xp, 1, -1  do
        local xp = worldobjects.xp[i]
        if not xp.magnet then
            if distanceBetween (player.x, player.y,xp.x,  xp.y) <= player.radius then
                xp.x = xp.x + math.cos(enemyPlayerAngle(xp)) * 5
                xp.y = xp.y + math.sin(enemyPlayerAngle(xp)) * 5
            end
        else    
            xp.x = xp.x + math.cos(enemyPlayerAngle(xp)) * 10
            xp.y = xp.y + math.sin(enemyPlayerAngle(xp)) * 10
        end
            if distanceBetween (player.x, player.y,xp.x, xp.y) <= 10 then
            player.xp = player.xp + xp.value
            table.remove(worldobjects.xp, i)
        end
    end
    for i=#worldobjects.items, 1, -1  do
        local item = worldobjects.items[i]
        if distanceBetween (player.x, player.y,item.x,  item.y) <= 50 then
            item.x = item.x + math.cos(enemyPlayerAngle(item)) * 5
            item.y = item.y + math.sin(enemyPlayerAngle(item)) * 5
        end
        if distanceBetween (player.x, player.y,item.x,  item.y) <= 10 then
            item.fn()
            table.remove(worldobjects.items, i)
        end
    end
end

function UpdatePlayer()
    if player.hp <= 0 then
        LoadMenuButtons()
        gamestate.state = 5
    end
    
    if player.xp >= player.maxXP then
        vx, vy = 0,0
        player.level = player.level +1
        player.xp = player.xp - player.maxXP
        player.maxXP = math.floor(player.maxXP *1.2)
        player.maxhp = player.maxhp + 5
        if player.hp < player.maxhp then
            player.hp = player.hp + math.floor((player.maxhp - player.hp) *0.2)
        end
        LoadUpgradeButtons()
        buttons.upgrades_available = RandomUpgrades()
        player.lvlup = true
        gamestate.state = 3
    end
end

-- Level Upgrade Options

function upgradeArrow_plus_firerate()
    if projectiles.arrow_plus.firerate >= 0.4 then
        projectiles.arrow_plus.firerate = projectiles.arrow_plus.firerate * 0.95
    end
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradeArrow_plus_damage()
    projectiles.arrow_plus.damage = projectiles.arrow_plus.damage + 0.25
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradeAxe_damage()
    projectiles.axe.damage = projectiles.axe.damage + 0.25
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradeAxe_firerate()
    projectiles.axe.firerate = projectiles.axe.firerate + 0.25
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradeAxe_pierce()
    projectiles.axe.hp = projectiles.axe.hp + 1
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradeArrow_plus_pierce()
    projectiles.arrow_plus.hp = projectiles.arrow_plus.hp + 1
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradePlayerSpeed()
    player.speed = player.speed + 5
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradePlayerMAXHP()
    player.maxhp = player.maxhp + 10
    if player.hp < player.maxhp - 10 then
        player.hp = player.hp +10
    else player.hp = player.maxhp
    end
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradePlayerRadius()
    player.radius = player.radius + 10
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradePlayerCritRate()
    player.critrate = player.critrate + 1
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradePlayerCritDamage()
    player.critdmg = player.critdmg + 0.2
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function upgradePlayerArmor()
    player.armor = player.armor + 1
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function healPlayerHP()
    if player.hp < player.maxhp - 50 then
        player.hp = player.hp + 50
    else player.hp = player.maxhp
    end
    buttons.upgrades_available = {}
    gamestate.state = 2
    player.lvlup = false
end

function newButton(text1, text2, text3, fn, desc)
    return {
        text1 = text1,
        text2 = text2,
        text3 = text3,
        fn = fn,
        now = false,
        last = false,
        desc = desc
    }
end

function LoadUpgradeButtons()
    buttons.upgrades = {}
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Arrow","Firerate",
        upgradeArrow_plus_firerate,
        "Increases how fast all arrows are being shot."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Arrow","Damage",
        upgradeArrow_plus_damage,
        "Increases the damage of all arrows."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Arrow","Pierce",
        upgradeArrow_plus_pierce,
        "Lets arrows pierce more enemies."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Axe","Damage",
        upgradeAxe_damage,
        "Increases damage of throwing axes."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Axe","Pierce",
        upgradeAxe_pierce,
        "Lets axes pierce more enemies."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Axe","Firerate",
        upgradeAxe_firerate,
        "Increases how fast all axes are being thrown."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Player","Speed",
        upgradePlayerSpeed,
        "Increases player movement speed."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Player","Max HP",
        upgradePlayerMAXHP,
        "Increases player's max HP."
    ))
    table.insert(buttons.upgrades, newButton(
        "Upgrade","Pickup","Radius",
        upgradePlayerRadius,
        "Increases XP pickup radius."
    ))
    table.insert(buttons.upgrades, newButton(
        "Player","HP","+50",
        healPlayerHP,
        "Heals the player by 50 points."
    ))  
    table.insert(buttons.upgrades, newButton(
        "Player","Crit","Damage",
        upgradePlayerCritDamage,
        "Increases the player's critical damage."
    ))
    table.insert(buttons.upgrades, newButton(
        "Player","Crit","Rate",
        upgradePlayerCritRate,
        "Increases the player's chance to deal critical damage."
    ))
    table.insert(buttons.upgrades, newButton(
        "Player","Armor","Rating",
        upgradePlayerArmor,
        "Increases the player's armor rating."
    ))
end

function RandomUpgrades()
    local upgrades = {}
    while #upgrades < 3 do
        local u = math.random(1, #buttons.upgrades)
        if not has_value(upgrades, buttons.upgrades[u]) then
            table.insert(upgrades, buttons.upgrades[u])
        end
    end
    return upgrades
end

function LoadMenuButtons()
    table.insert(buttons.pause, newButton(
        "Continue", nil, nil,
        resumeGame,
        "Resume the game"
    ))
    table.insert(buttons.pause, newButton(
        "New Game", nil, nil,
        newGame,
        "Start a new game"
    ))
    table.insert(buttons.pause, newButton(
        "Settings", nil, nil,
        goToSettings,
        "Open the settings menu"
    ))
    table.insert(buttons.pause, newButton(
        "Exit Game", nil, nil,
        love.event.quit,
        "Close the game"
    ))
end

function has_value(tab, val)
    local hasvalue = false
    for i, v in ipairs(tab) do
        if v == val then
            hasvalue = true
        end
    end
    return hasvalue
end

function getallXP() 
    for i=#worldobjects.xp, 1, -1  do
        local xp = worldobjects.xp[i]
        xp.magnet = true
    end
end

function damageEnemyType(enemytable)
    for _, enemy in ipairs(enemytable) do
        enemy.hp = enemy.hp - 5
    end
end

function bomb_damage()
    damageEnemyType(enemies.spiders)
    damageEnemyType(enemies.ghosts)
    damageEnemyType(enemies.bats)
end

function calc_damage(weapon)
    local dmg = 0
    local crit = math.random(1,100)
    if crit <= player.critrate then
        dmg = weapon.damage * player.critdmg
        gamestate.showNotification = true
        gamestate.notification = "CRIT!"
        print("CRIT!")
    else 
        dmg = weapon.damage
    end
    return dmg
end

--------------------
--------------------
------DRAW ALL------
--------------------
--------------------

--Draw all enemies
function drawEnemies(enemytable, enemysprite)
    for i, s in ipairs(enemytable) do
        love.graphics.setColor(.92,0.13,0.15) --red
        love.graphics.rectangle("fill", s.x-5, s.y-25, enemysprite:getWidth(), 2)
        love.graphics.setColor(0.33,0.82,0.33) --green
        love.graphics.rectangle("fill", s.x-5, s.y-25, enemysprite:getWidth()*(s.hp/s.maxhp), 2)
        love.graphics.setColor(1,1,1,1)
        love.graphics.draw(enemysprite, s.x, s.y, enemyPlayerAngle(s) - math.pi/2, 1.8, 1.8, enemysprite:getWidth()/2,enemysprite:getHeight()/2)
    end
end

function drawAllEnemies()
    drawEnemies(enemies.spiders, sprites.spider)
    drawEnemies(enemies.ghosts, sprites.ghost)
    drawEnemies(enemies.bats, sprites.bat)
end

function drawItems()
    for i, item in ipairs(worldobjects.items) do
        if item.sprite == sprites.potion then
            love.graphics.draw(item.sprite, item.x, item.y, nil, 2.5, 2.5,item.sprite:getWidth()/2,item.sprite:getHeight()/2)
        else
            love.graphics.draw(item.sprite, item.x, item.y, nil, nil,nil,item.sprite:getWidth()/2,item.sprite:getHeight()/2)
        end
    end
end

function drawXP()
    for i, xp in ipairs(worldobjects.xp) do
        if xp.value == 3 then
            love.graphics.setColor(1,0.7,0.9,1)
        elseif xp.value == 5 then
            love.graphics.setColor(0.4,0.6,0.91)
        else 
            love.graphics.setColor(1,1,1,1)
        end
        love.graphics.rectangle("fill", xp.x, xp.y, 7,7)
        love.graphics.setColor(1,1,1,1)
    end
end

function drawArrow_plus()
    for i,apu in ipairs(projectiles.arrow_plus.up) do
        love.graphics.draw(sprites.arrowUP, apu.collider:getX()-1, apu.collider:getY()+13, nil,1.5,1.5,sprites.arrowUP:getWidth()/2, sprites.arrowUP:getHeight()/2)
    end

    for i,apd in ipairs(projectiles.arrow_plus.down) do
        love.graphics.draw(sprites.arrowDOWN, apd.collider:getX()+1, apd.collider:getY()-13, nil,1.5,1.5, sprites.arrowDOWN:getWidth()/2, sprites.arrowDOWN:getHeight()/2)
    end
    
    for i,apl in ipairs(projectiles.arrow_plus.left) do
        love.graphics.draw(sprites.arrowLEFT, apl.collider:getX()+13, apl.collider:getY()+1, nil, 1.5,1.5,sprites.arrowLEFT:getWidth()/2, sprites.arrowRIGHT:getHeight()/2)
    end

    for i,apr in ipairs(projectiles.arrow_plus.right) do
        love.graphics.draw(sprites.arrowRIGHT, apr.collider:getX()-13, apr.collider:getY(), nil, 1.5,1.5,sprites.arrowLEFT:getWidth()/2, sprites.arrowRIGHT:getHeight()/2)
    end
end

function drawAxe()
    for i,axe in ipairs(projectiles.axe) do
        local angle = love.timer.getTime() * math.pi/0.26
        love.graphics.draw(sprites.axe, axe.collider:getX(), axe.collider:getY()+1, angle,2,2,sprites.axe:getWidth()/2, sprites.axe:getHeight()/2)
    end
end

function drawSaw()
    for _, saw in ipairs(projectiles.saw) do
        love.graphics.draw(sprites.saw, player.x, player.y+sprites.axe:getHeight()/2, saw.angle,nil,nil,100,100)
    end
end

function drawAllWeapons()
    drawArrow_plus()
    drawAxe()
    drawSaw()
end

function drawHUD()
    drawHPBar()
    drawXPBar()
end

function drawPlayer()
    player.direction:draw(sprites.player, player.x, player.y, nil, .8, .8, 36, 43)
end

-- Player HP Bar
function drawHPBar()
    love.graphics.setFont(fonts.PixelFontNormal)
    --love.graphics.setColor(0,0,0) --black
    --love.graphics.rectangle("fill",SCREEN_WIDTH/2 - ((SCREEN_WIDTH/4+6)/2) , SCREEN_HEIGHT/10,SCREEN_WIDTH/4+6, SCREEN_HEIGHT/25+7)
    local hpW = SCREEN_WIDTH/4
    local hpH = SCREEN_HEIGHT/34
    love.graphics.setColor(.92,0.13,0.15) --red
    love.graphics.rectangle("fill", SCREEN_WIDTH/2 - hpW/2, SCREEN_HEIGHT-SCREEN_HEIGHT/10, hpW, hpH)
    love.graphics.setColor(0.33,0.82,0.33) --green
    love.graphics.rectangle("fill", SCREEN_WIDTH/2 - hpW/2, SCREEN_HEIGHT-SCREEN_HEIGHT/10, hpW*(player.hp/player.maxhp), hpH)
    love.graphics.setColor(1,1,1)
    local currenthp = "HP: " .. player.hp .. "/" .. player.maxhp
    love.graphics.printf(currenthp, SCREEN_WIDTH/2 - fonts.PixelFontNormal:getWidth(currenthp)/2, SCREEN_HEIGHT - SCREEN_HEIGHT/10+7, fonts.PixelFontNormal:getWidth(currenthp), "center")
end

-- Player XP Bar
function drawXPBar()
    love.graphics.setColor(0,0,0) --black
    love.graphics.rectangle("fill",0,0,SCREEN_WIDTH, 20)
    love.graphics.setColor(1,1,1) --white
    love.graphics.rectangle("fill", 0,0, SCREEN_WIDTH * (player.xp / player.maxXP), 20)
    love.graphics.setColor(.92,0.13,0.15) --red
    --love.graphics.printf("Level: " .. player.level .. "        " .. player.xp .. "/" .. player.maxXP, 0,2,SCREEN_WIDTH, "center")
    love.graphics.setColor(1,1,1) --white
end

function drawLvLUp()
    -- Level Up Screen
    love.graphics.setFont(fonts.PixelFontNormal)
    love.graphics.setColor(0,0,0,0.7) -- black with transparency
    love.graphics.rectangle("fill",0,0, SCREEN_WIDTH, SCREEN_HEIGHT)
    love.graphics.setColor(1,1,1) --white
    love.graphics.printf("LEVEL UP!", 0, SCREEN_WIDTH/10, SCREEN_WIDTH, "center")
    
    local button_width = SCREEN_WIDTH / 4
    local button_height = SCREEN_HEIGHT / 3
    local margin = SCREEN_WIDTH/25
    local total_width = (button_width + margin) * #buttons.upgrades_available
    local cursor_x = margin/2
    local mx, my = love.mouse.getPosition()
    
    for i, b in ipairs(buttons.upgrades_available) do
        b.last = b.now
        local bx = SCREEN_WIDTH/2 - total_width/2 + cursor_x
        local by = SCREEN_HEIGHT/2 - button_height/2

        local color = {1,1,1,1} --white

        local hot = mx > bx and mx < bx + button_width and 
                    my > by and my < by + button_height

        if hot then
            color = {0.4,0.4,0.5,1.0}
        end
        
        b.now = love.mouse.isDown(1)
        if b.now and hot then
            color = {0.2,0.2,0.2,1.0}
        elseif b.last and hot then
            b.fn()
        end 

        local textW = fonts.PixelFontNormal:getWidth("Upgrade")-margin
        local textH = fonts.PixelFontNormal:getHeight(b.text1)

        love.graphics.setColor(unpack(color))
        love.graphics.rectangle ("fill", bx,by, button_width, button_height)
        love.graphics.setColor(0,0,0,1)
        love.graphics.printf(b.text1, fonts.PixelFontNormal, bx + button_width/2 - fonts.PixelFontNormal:getWidth(b.text1)/2, by, fonts.PixelFontNormal:getWidth(b.text1),"center")
        love.graphics.printf(b.text2, fonts.PixelFontNormal, bx + button_width/2 - fonts.PixelFontNormal:getWidth(b.text2)/2, by + margin, fonts.PixelFontNormal:getWidth(b.text2),"center")
        love.graphics.printf(b.text3, fonts.PixelFontNormal, bx + button_width/2 - fonts.PixelFontNormal:getWidth(b.text3)/2, by + margin*2, fonts.PixelFontNormal:getWidth(b.text3),"center")
        --love.graphics.printf(b.desc, fonts.PixelFontNormal, bx + button_width/2 - fonts.PixelFontNormal:getWidth(b.desc)/3+margin, by + button_height/2+margin, fonts.PixelFontNormal:getWidth(b.desc)/3,"center")

        cursor_x = cursor_x + (button_width + margin)
    end
    
    local cursor_x = margin/2
    for i, b in ipairs(buttons.upgrades_available) do
        local bx = SCREEN_WIDTH/2 - total_width/2 + cursor_x
        local by = SCREEN_HEIGHT/2 - button_height/2
        local hot = mx > bx and mx < bx + button_width and 
                    my > by and my < by + button_height
        if hot then
            
            if mx + fonts.defaultFont:getWidth(b.desc)+ margin > SCREEN_WIDTH then
                love.graphics.setColor(1,1,1,1)
                love.graphics.rectangle("fill", mx-5, my, fonts.defaultFont:getWidth(b.desc)/2+ margin,40, 10, 10, 5)
                love.graphics.setColor(0,0,0,1)
                love.graphics.rectangle("line", mx-5, my, fonts.defaultFont:getWidth(b.desc)/2+ margin,40, 10, 10, 5)
                love.graphics.setFont(fonts.defaultFont)
                love.graphics.printf(b.desc, mx + margin/2, my + 6,fonts.defaultFont:getWidth(b.desc)/2 )
            else 
                love.graphics.setColor(1,1,1,1)
                love.graphics.rectangle("fill", mx-5, my, fonts.defaultFont:getWidth(b.desc)+ margin,20, 10, 10, 5)
                love.graphics.setColor(0,0,0,1)
                love.graphics.rectangle("line", mx-5, my, fonts.defaultFont:getWidth(b.desc)+ margin,20, 10, 10, 5)
                love.graphics.setFont(fonts.defaultFont)
                love.graphics.printf(b.desc, mx + margin/2, my + 6,fonts.defaultFont:getWidth(b.desc) )
            end
            
        end
        cursor_x = cursor_x + (button_width + margin)
    end
    love.graphics.setColor(1,1,1,1)
end

function drawPause()
    love.graphics.setFont(fonts.PixelFontNormal)
    love.graphics.setColor(0,0,0,0.9) -- black with transparency
    love.graphics.rectangle("fill",0,0, SCREEN_WIDTH, SCREEN_HEIGHT)
    love.graphics.setColor(1,1,1) --white
    love.graphics.printf("PAUSE", 0, SCREEN_WIDTH/10, SCREEN_WIDTH, "center")

    local button_width = SCREEN_WIDTH / 3
    local button_height = SCREEN_HEIGHT / 20
    local margin = SCREEN_WIDTH/25
    local total_width = (button_width + margin) * #buttons.pause
    local total_height = (button_height + margin) * #buttons.pause
    local cursor_y = margin/2


    for i, b in ipairs(buttons.pause) do
        
    love.graphics.setFont(fonts.PixelFontNormal)
        b.last = b.now
        local bx = SCREEN_WIDTH/2 - button_width/2
        local by = SCREEN_HEIGHT/2 - total_height/2 + cursor_y
        local mx, my = love.mouse.getPosition()

        local color = {1,1,1,1} --white

        local hot = mx > bx and mx < bx + button_width and 
                    my > by and my < by + button_height

        if hot then
            color = {0.4,0.4,0.5,1.0}
        
            
        end
        
        
        b.now = love.mouse.isDown(1)
        if b.now and hot then
            color = {0.2,0.2,0.2,1.0}
        elseif b.last and hot then
            b.fn()
        end 

        local textW = fonts.PixelFontNormal:getWidth(b.text1) - margin
        local textH = fonts.PixelFontNormal:getHeight(b.text1) - margin

        love.graphics.setColor(unpack(color))
        love.graphics.rectangle ("fill", bx,by, button_width, button_height,10,10,5)
        love.graphics.setColor(0,0,0,1)
        love.graphics.printf(b.text1, fonts.PixelFontNormal, bx + button_width/2 - fonts.PixelFontNormal:getWidth(b.text1)/2,by + button_height/2 - textH/2-margin/2, fonts.PixelFontNormal:getWidth(b.text1),"center")
        cursor_y = cursor_y + (button_height + margin)
        if hot then
            love.graphics.setColor(1,1,1,1)
            love.graphics.rectangle("fill", mx-5, my, fonts.PixelFontSmall:getWidth(b.desc)+ margin,20, 5, 5, 5)
            love.graphics.setColor(0,0,0,1)
            love.graphics.rectangle("line", mx-5, my, fonts.PixelFontSmall:getWidth(b.desc)+ margin,20, 5, 5, 5)
            love.graphics.setFont(fonts.PixelFontSmall)
            love.graphics.printf(b.desc, mx + margin/2-5, my + 6,fonts.PixelFontSmall:getWidth(b.desc) )
        end

    end
    love.graphics.setColor(1,1,1,1)
    
end

function drawGameOver()
    love.graphics.setFont(fonts.PixelFontNormal)
    love.graphics.setColor(0,0,0,0.9) -- black with transparency
    love.graphics.rectangle("fill",0,0, SCREEN_WIDTH, SCREEN_HEIGHT)
    love.graphics.setColor(1,1,1) --white
    love.graphics.printf("GAME OVER!", 0, SCREEN_WIDTH/10, SCREEN_WIDTH, "center")

    local button_width = SCREEN_WIDTH / 3
    local button_height = SCREEN_HEIGHT / 20
    local margin = SCREEN_WIDTH/25
    local total_width = (button_width + margin) * (#buttons.pause-1)
    local total_height = (button_height + margin) * (#buttons.pause-1)
    local cursor_y = margin/2


    for i, b in ipairs(buttons.pause) do
        b.last = b.now
        local bx = SCREEN_WIDTH/2 - button_width/2
        local by = SCREEN_HEIGHT/2 - total_height/2 + cursor_y
        local mx, my = love.mouse.getPosition()
        
        local color = {1,1,1,1} --white
        
        local hot = mx > bx and mx < bx + button_width and 
        my > by and my < by + button_height
        
        if hot then
            color = {0.4,0.4,0.5,1.0}
        end
        
        b.now = love.mouse.isDown(1)
        if b.now and not b.last and hot then
            b.fn()
        end
        
        local textW = fonts.PixelFontNormal:getWidth(b.text1) - margin
        local textH = fonts.PixelFontNormal:getHeight(b.text1) - margin
        
            love.graphics.setColor(unpack(color))
            love.graphics.rectangle ("fill", bx,by, button_width, button_height,10,10,5)
            love.graphics.setColor(0,0,0,1)
            love.graphics.printf(b.text1, fonts.PixelFontNormal, bx + button_width/2 - fonts.PixelFontNormal:getWidth(b.text1)/2,by + button_height/2 - textH/2-margin/2, fonts.PixelFontNormal:getWidth(b.text1),"center")
            cursor_y = cursor_y + (button_height + margin)
            if hot then
                love.graphics.setColor(1,1,1,1)
                love.graphics.rectangle("fill", mx, my, fonts.PixelFontSmall:getWidth(b.desc)+ margin,20, 10, 10, 5)
                love.graphics.setColor(0,0,0,1)
                love.graphics.setFont(fonts.PixelFontSmall)
                love.graphics.printf(b.desc, mx + margin/2, my + 6,fonts.PixelFontSmall:getWidth(b.desc) )
            end
    end
    love.graphics.setColor(1,1,1,1)
    
end

function drawPlayerStats()
    love.graphics.setFont(fonts.PixelFontNormal)
    love.graphics.setColor(0,0,0,0.7) -- black with transparency
    love.graphics.rectangle("fill",0,0, SCREEN_WIDTH, SCREEN_HEIGHT)
    love.graphics.setColor(1,1,1,1) --white
    local playerstats ="ARROW DAMAGE: " .. projectiles.arrow_plus.damage .. 
                        "\n\nARROW FIRERATE: " .. projectiles.arrow_plus.firerate .. 
                        "\n\nAXE DAMAGE: " .. projectiles.axe.damage ..
                        "\n\nAXE FIRERATE: " .. projectiles.axe.firerate ..
                        "\n\nPLAYER PICKUP RADIUS: " .. player.radius ..
                        "\n\nPLAYER SPEED: " .. player.speed ..
                        "\n\nPLAYER LEVEL: " .. player.level ..
                        "\n\nCRIT CHANCE:: " .. player.critrate ..
                        "\n\nCRIT DAMAGE:: " .. player.critdmg ..

                        "\n\nSPAWN RATE: " .. gamestate.currentSpawnTimer
    love.graphics.printf(playerstats,
                        10,
                        30,
                        SCREEN_WIDTH,
                        "left")
end

function drawMapNoPlayer()
    cam:attach()

    -- Scales the map by the factor of gamestate.scale
    love.graphics.push()
    love.graphics.scale(gamestate.scale)

    -- Draws every layer
    game_map:drawLayer(game_map.layers["Ground"])
    game_map:drawLayer(game_map.layers["Second Layer"])
    game_map:drawLayer(game_map.layers["Deco"])
    game_map:drawLayer(game_map.layers["Above Player"])

    love.graphics.pop()
    cam:detach()
end

function drawNotification()
    if gamestate.showNotification == true then
        love.graphics.printf(gamestate.notification, 0, SCREEN_WIDTH/10, SCREEN_WIDTH, "center")
    end
end

function newGame()
    love.load()
end

function resumeGame()
    gamestate.state = 2
end

function goToSettings()
    gamestate.state = 6
end

function SpawnEnemies(dt)
    if player.level < 5 then
        table.insert(enemies.spawntable, SpawnSpider)
    elseif player.level > 4 and player.level < 11 then
        table.insert(enemies.spawntable, SpawnGhost)
    else 
        table.insert(enemies.spawntable, SpawnBat)
    end
    gamestate.spawnTimer = gamestate.spawnTimer - dt
    if gamestate.spawnTimer <= 0 then
        local rnd = math.random(#enemies.spawntable)
        enemies.spawntable[rnd]()
        if gamestate.currentSpawnTimer >= gamestate.minSpawnTimer then
            gamestate.currentSpawnTimer = gamestate.currentSpawnTimer * 0.998
        end
        gamestate.spawnTimer = gamestate.currentSpawnTimer
    end
end